"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Coordinates(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "assembly",
        "chromosome",
        "end",
        "start",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "ciEnd": reports_6_5_0.ConfidenceInterval,
            "ciStart": reports_6_5_0.ConfidenceInterval,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "assembly": reports_6_5_0.Assembly,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "org.gel.models.report.avro.Assembly": reports_6_5_0.Assembly,
            "org.gel.models.report.avro.ConfidenceInterval": reports_6_5_0.ConfidenceInterval,
            "org.gel.models.report.avro.ConfidenceInterval": reports_6_5_0.ConfidenceInterval,
            "org.gel.models.report.avro.Coordinates": reports_6_5_0.Coordinates,
        }

    __slots__ = [
        "assembly",
        "chromosome",
        "end",
        "start",
        "ciEnd",
        "ciStart",
    ]

    def __init__(
        self,
        assembly,
        chromosome,
        end,
        start,
        ciEnd=None,
        ciStart=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_5_0.Coordinates model.

        :param assembly:
            The assembly to which this variant corresponds
        :type assembly: Assembly
        :param chromosome:
            Chromosome without "chr" prefix (e.g. X rather than chrX)
        :type chromosome: str
        :param end:
            End genomic position for variant
        :type end: int
        :param start:
            Start genomic position for variant (1-based)
        :type start: int
        :param ciEnd:
        :type ciEnd: None | ConfidenceInterval
        :param ciStart:
        :type ciStart: None | ConfidenceInterval
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.5.0"
